;;;; srfi-4-checks.scm  -*- Scheme -*-
;;;; Kon Lovett, Jul '18
;;;; Kon Lovett, Dec '09

(module srfi-4-checks

(;export
  check-s8vector
  check-u8vector
  check-s16vector
  check-u16vector
  check-s32vector
  check-u32vector
  check-s64vector
  check-u64vector
  check-f32vector
  check-f64vector)

(import scheme)
(import (chicken base))			; for `include'
(import (chicken type))
(import (srfi 4))
(import type-checks-basic)
(import srfi-4-errors)

(: check-s8vector (* * #!optional * -> s8vector))
(: check-u8vector (* * #!optional * -> u8vector))
(: check-s16vector (* * #!optional * -> s16vector))
(: check-u16vector (* * #!optional * -> u16vector))
(: check-s32vector (* * #!optional * -> s32vector))
(: check-u32vector (* * #!optional * -> u32vector))
(: check-s64vector (* * #!optional * -> s64vector))
(: check-u64vector (* * #!optional * -> u64vector))
(: check-f32vector (* * #!optional * -> f32vector))
(: check-f64vector (* * #!optional * -> f64vector))

(define-check-type s8vector)
(define-check-type u8vector)
(define-check-type s16vector)
(define-check-type u16vector)
(define-check-type s32vector)
(define-check-type u32vector)
(define-check-type s64vector)
(define-check-type u64vector)
(define-check-type f32vector)
(define-check-type f64vector)

) ;module srfi-4-checks
